

AddCSLuaFile("cl_init.lua");
AddCSLuaFile("shared.lua");
include('entities/base_wire_entity/init.lua'); 
include("shared.lua");

globalgravcontrollernumber = 0 --only the gravcon with the highest number on a contraption can check it every second, avoids lag

function ENT:Initialize()

	math.randomseed(CurTime())

	if self.model then
		self.Entity:SetModel(self.model)
	else
		self.Entity:SetModel("models/Cebt/sga_pwnode.mdl")
	end
	
	if (!self.HoverSound) then
		self.HoverSound = 'ambient/atmosphere/underground_hall_loop1.wav'
	end
	if (!self.Sound) then
		self.Sound = CreateSound( self.Entity, self.HoverSound )
	end	

	self.Entity:PhysicsInit( SOLID_VPHYSICS )
    self.Entity:SetMoveType( MOVETYPE_VPHYSICS )
    self.Entity:SetSolid( SOLID_VPHYSICS )

    self.phys = self.Entity:GetPhysicsObject()
	if (self.phys:IsValid()) then
		self.phys:Wake();
	end
	
	self.Inputs = Wire_CreateInputs( self.Entity, {"Activate" , "AirbrakeX" , "AirbrakeY" , "AirbrakeZ" , "GlobalBrake"} )
	self.CanUse = true
	self.IsGravcontroller = true
	self.PitchStartup = 0
	self.Active = false
	self.IsPowernode = 0
	self.ActiveSPC = false
	
	globalgravcontrollernumber = globalgravcontrollernumber + 1
	self.gravcontrollernumber = globalgravcontrollernumber
	
end

function ENT:UpdateTransmitState() return TRANSMIT_ALWAYS end

function ENT:TriggerInput(iname, value)

	if(iname == "Activate") then		
		if(value == 1) then
			self:ActivateIt(true)
		else
			self:ActivateIt(false)
		end
	end

	if(iname == "AirbrakeX") then
		if value > 100 then 
			value = 100
		end
		self.AirbrakeX = value
	end

	if(iname == "AirbrakeY") then
		if value > 100 then 
			value = 100
		end
		self.AirbrakeY = value
	end

	if(iname == "AirbrakeZ") then
		if value > 100 then 
			value = 100
		end
		self.AirbrakeZ = value
	end

	if(iname == "GlobalBrake") then
		if value > 100 then
			value = 100
		end
		self.brakepercent = value
	end
	
end

function ENT:ActivateIt(bool)
	
	--###### Fetch constrained entities and switch grav on/off
	self.ConstrainedEntities = constraint.GetAllConstrainedEntities( self.Entity )
	
	if self.AirbrakeOnly and self.AirbrakeOnly == 0 or !self.AirbrakeOnly then
		for _, ConstrEnt in pairs( self.ConstrainedEntities ) do
			if (!ConstrEnt:IsValid()) then return end
			if !ConstrEnt.phys then
				ConstrEnt.phys = ConstrEnt:GetPhysicsObject()
			end
			if bool then
				if ConstrEnt.grav == 1 or !ConstrEnt.grav then
					ConstrEnt.grav = 0
					ConstrEnt.phys:EnableGravity(false)
				end
			elseif !bool then
				if ConstrEnt.grav == 0 or !ConstrEnt.grav then
					if self.environment and ( self.environment:IsSpace() or self.environment:IsStar() )then
						self.Owner:PrintMessage( HUD_PRINTTALK, "You are in Space. You can't turn off gravity here!" )  
					return end
					ConstrEnt.grav = 1
					ConstrEnt.phys:EnableGravity(true)
				end
			end
		end	
	end
		
	if bool and !self.Active then 
		
		if self.DrawSprite == 1 then self:SetNWBool("drawsprite",true) end
		self.Sound:Play()
		self.SoundPlaying = true
		self.Sound:ChangePitch( self.PitchStartup )
		self.ActivePitch = true
		self.Active = true
		
	elseif !bool and self.Active then

		self.phys:Wake()	
		self:ActSPC(false)
		self:SetNWBool("drawsprite", false)
		self.Active = false
		self.ActivePitch = false
		
	end	
end

function ENT:ActSPC(b)
	
	if b and self.Active then
	
		if self.DrawSprite == 0 then self:SetNWBool("drawsprite",true) end
		self.IsPowernode = 1
		self.TargetPos = self.Entity:GetPos()
		self.ActiveSPC = true
	
	else
	
		if self.DrawSprite == 0 then self:SetNWBool("drawsprite",false) end
		self.IsPowernode = 0
		self.ActiveSPC = false
		self.TargetPos = nil
	
	end


end

function ENT:Use( a, c ) 
	if !(a == self.Owner) then return end
	if self.Active and self.CanUse then
		self.CanUse = false
		timer.Simple(1, function() self.CanUse = true end)
		self:ActivateIt(false)
	elseif !self.Active and self.CanUse then
		self.CanUse = false
		timer.Simple(1, function() self.CanUse = true end)
		self:ActivateIt(true)
	end
	return false
end

function ENT:PhysicsUpdate(physobj)

	local pos = self.Entity:GetPos()

	if self.PitchStartup == 100 then
	
		local soundvel = self.Entity:GetVelocity():Length()
		if soundvel > 900 then soundvel = 900  end
		self.Sound:ChangePitch( 100 + ( soundvel / 6 ) );
		
	end
	
	if(self.globalbrake == 0 and !self.ActiveSPC and (self.Active or self.AlwaysAirbrake == 1)) then

		local vel = self.Entity:WorldToLocal(self.Entity:GetVelocity()+pos)	
		local velx = vel.x - vel.x * self.AirbrakeX/100
		local vely = vel.y - vel.y * self.AirbrakeY/100
		local velz = vel.z - vel.z * self.AirbrakeZ/100
	
		if self.phys:IsValid() then
			self.phys:SetVelocity(self.Entity:LocalToWorld( Vector(velx , vely , velz) )-pos)
		end

	elseif(self.globalbrake == 1 and !self.ActiveSPC and (self.Active or self.AlwaysAirbrake == 1)) then
	
			local vel = self.phys:GetVelocity()
			vel = vel * ((100.0 - self.brakepercent)/100.0)
			self.phys:SetVelocity(vel)

	end
	
	if (self.angbrake == 1 and !self.ActiveSPC and (self.Active or self.AlwaysAirbrake == 1)) then
	
		local avel = self.phys:GetAngleVelocity()
		if self.brakepercent > 100 then self.brakepercent = 100 end
		self.VeloC = ( Angle( 0,0,0 ) - avel )
		self.phys:AddAngleVelocity(( self.brakepercent / 100 )*self.VeloC )
		
	end
	
	if self.ActiveSPC then
	
		local diff = self.TargetPos - pos
		vel = diff * 0.5
		
		self.phys:SetVelocity(vel)
	
	end

end

function ENT:OnRemove()

	self.Sound:Stop()

end

function ENT:Think()
	if self.ActivePitch then
		self.PitchStartup = math.min( self.PitchStartup + 1, 100 )
	else
		self.PitchStartup = math.max( self.PitchStartup - 1, 0 )
		if self.PitchStartup == 0 then
			if self.SoundPlaying then
				self.Sound:Stop()
				self.SoundPlaying = false
			end
		end
	end
	if self.SoundPlaying then
		self.Sound:ChangePitch(self.PitchStartup)
	end
	if self.PitchStartup < 100 then
		self:NextThink(CurTime())
	elseif self.PitchStartup == 100 then
		self:NextThink(CurTime()+0.5)
		if !self.Active or self.AirbrakeOnly and self.AirbrakeOnly == 1 then return true end
		self.ConstrEnts = constraint.GetAllConstrainedEntities(self.Entity)
		for _, ConstrEnt in pairs(self.ConstrEnts) do
			if (ConstrEnt.IsGravcontroller and ConstrEnt.gravcontrollernumber > self.gravcontrollernumber) then return end
			if (!ConstrEnt:IsValid()) then return end
			if !ConstrEnt.phys then
				ConstrEnt.phys = ConstrEnt:GetPhysicsObject()
			end
			if (ConstrEnt.grav == 1 or !ConstrEnt.grav) or (ConstrEnt.gravity == 1 and ConstrEnt.WasInSpace) then
				ConstrEnt.phys:EnableGravity(false)
				ConstrEnt.grav = 0
				ConstrEnt.WasInSpace = false
			end
			if ConstrEnt.gravity and ConstrEnt.gravity == 0 then
				ConstrEnt.WasInSpace = true
			end
		end
	end
	return true
end
		
local function FireGravitycontroller( ply, ent )
	pyractivator = ply
	if !ent:IsValid() then return false end
	if ent.Active then
		ent:ActivateIt(false)
	else
		ent:ActivateIt(true)
	end
end
	
local function FireSPC( ply, ent )
	pyractivator = ply
	if !ent:IsValid() then return false end
	if ent.ActiveSPC then
		ent:ActSPC(false)
	else
		ent:ActSPC(true)
	end
end

numpad.Register( "FireSPC", FireSPC )
numpad.Register( "FireGravitycontroller", FireGravitycontroller )
