TOOL.Category = 'Construction'
TOOL.Name = '#Gravity Controller'
TOOL.Command = nil
TOOL.ConfigName = ''

models = {
	{ 'Teapot', 'models/props_interiors/pot01a.mdl' },
	{ 'Spacegate Powernode', 'models/Col Sheppard/spacegate.mdl' },
	{ 'Pot', 'models/props_interiors/pot02a.mdl' },
	{ 'Skull', 'models/Gibs/HGIBS.mdl' },
	{ 'Clock', 'models/props_c17/clock01.mdl' },
	{ 'Hula Doll', 'models/props_lab/huladoll.mdl' },
	{ 'Hover Drive', 'models//props_c17/utilityconducter001.mdl' },
	{ 'Big Hover Drive', 'models/props_wasteland/laundry_washer003.mdl' },
	{ 'SpacegatePowernode', 'models/Cebt/sga_pwnode.mdl' },
}

TOOL.List = "GravControllerModels"
list.Set(TOOL.List,"models/props_combine/weaponstripper.mdl",{Angle=Angle(-90,0,0),Position=Vector(15,0,-60)})
list.Set(TOOL.List,"models/props_docks/dock01_cleat01a.mdl",{})
list.Set(TOOL.List,"models/props_junk/plasticbucket001a.mdl",{})
list.Set(TOOL.List,"models/props_junk/propanecanister001a.mdl",{})
list.Set(TOOL.List,"models/props_wasteland/laundry_washer003.mdl",{})
list.Set(TOOL.List,"models/props_wasteland/laundry_washer001a.mdl",{})
list.Set(TOOL.List,"models/props_lab/huladoll.mdl",{})
list.Set(TOOL.List,"models/props_trainstation/trashcan_indoor001a.mdl",{})
list.Set(TOOL.List,"models/props_c17/clock01.mdl",{})
list.Set(TOOL.List,"models/props_phx/construct/metal_plate1.mdl",{})
list.Set(TOOL.List,"models/props_combine/breenclock.mdl",{})
list.Set(TOOL.List,"models/props_combine/breenglobe.mdl",{})
list.Set(TOOL.List,"models/props_interiors/pot01a.mdl",{})
list.Set(TOOL.List,"models/props_junk/metal_paintcan001a.mdl",{})
list.Set(TOOL.List,"models/props_junk/popcan01a.mdl",{})
list.Set(TOOL.List,"models/Col Sheppard/spacegate.mdl",{})
list.Set(TOOL.List,"models/Cebt/sga_pwnode.mdl",{})


loopsounds = {
	{ 'No Sound', '' },
	{ 'Scanner', 'npc/scanner/combat_scan_loop2.wav' },
	{ 'Heli rotor', 'NPC_CombineGunship.RotorSound' },
	{ 'combine shield', 'ambient/machines/combine_shield_loop3.wav' },
	{ 'dog idlemode', 'npc/dog/dog_idlemode_loop1.wav' },
	{ 'dropship', 'npc/combine_gunship/dropship_engine_distant_loop1.wav' },
	{ 'subway hall 1', 'ambient/atmosphere/undercity_loop1.wav' },
	{ 'subway hall 2', 'ambient/atmosphere/underground_hall_loop1.wav' },
	{ 'combine forcefield', 'ambient/energy/force_field_loop1.wav' },
	{ 'engine rotor', 'npc/combine_gunship/engine_rotor_loop1.wav' }	
}

TOOL.ClientConVar['ActivateKey'] = '0'
TOOL.ClientConVar['ActivateSPC'] = ''
TOOL.ClientConVar['AirbrakeX']	= '15'
TOOL.ClientConVar['AirbrakeY']	= '15'
TOOL.ClientConVar['AirbrakeZ']	= '15'
TOOL.ClientConVar['BrakePercent'] = "10"
TOOL.ClientConVar['model'] = 'models//props_c17/utilityconducter001.mdl'
TOOL.ClientConVar['sound'] = 'ambient/atmosphere/underground_hall_loop1.wav'
TOOL.ClientConVar['AngularAirbrake'] = 0
TOOL.ClientConVar['GlobalBrake'] = 0
TOOL.ClientConVar['DrawSprite'] = 1
TOOL.ClientConVar['AirbrakeAlwaysOn'] = 1
TOOL.ClientConVar['AirbrakeOnly'] = 0

if ( CLIENT ) then
	language.Add( 'gravitycontroller', 'Gravity Controller' )
	language.Add( 'Tool_gravitycontroller_name', "Gravity Controller Creator" )
	language.Add( 'Tool_gravitycontroller_desc', 'Build Starships without hoverballs, or simply use it for stabilizing your stuff' )
	language.Add( 'Tool_gravitycontroller_0', 'Click where you would like to create a Gravity Controller, click on one to update it.' )

	language.Add( 'Undone_gravitycontroller', 'Gravity Controller Undone' )
	language.Add( 'Cleanup_gravitycontroller', 'Gravity Controller' )
	language.Add( 'Cleaned_gravitycontroller', 'Cleaned up all Gravity Controllers' )
	language.Add( 'SBoxLimit_gravitycontroller', 'Maximum amount of Gravity Controllers reached' )
end


function TOOL:LeftClick( trace )
	if trace.Entity && (trace.Entity:IsPlayer() ) then return false end
	if(CLIENT) then
		return true
	end

	if(!SERVER) then return false end

	local ply = self:GetOwner()
	local Pos = trace.HitPos
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	
	local ActivateKey		= self:GetClientNumber	( 'ActivateKey' )
	local model 			= self:GetClientInfo	( "model" )
	local AirbrakeX			= self:GetClientNumber	( 'AirbrakeX' )
	local AirbrakeY			= self:GetClientNumber	( 'AirbrakeY' )
	local AirbrakeZ			= self:GetClientNumber	( 'AirbrakeZ' )
	local brakepercent		= self:GetClientNumber	( 'BrakePercent' )
	local sound				= self:GetClientInfo	( 'sound' )
	local AngularAirbrake	= self:GetClientNumber	( 'AngularAirbrake' )
	local globalbrake		= self:GetClientNumber	( 'GlobalBrake' )
	local ActivateSPC		= self:GetClientNumber	( 'ActivateSPC' )
	local DrawSprite		= self:GetClientNumber	( 'DrawSprite' )
	local AlwaysAirbrake	= self:GetClientNumber	( 'AirbrakeAlwaysOn' )
	local AirbrakeOnly		= self:GetClientNumber	( 'AirbrakeOnly' )
	
	if ( trace.Entity:IsValid() && trace.Entity:GetClass() == "gravitycontroller" ) then
		trace.Entity.AirbrakeX	= AirbrakeX
		trace.Entity.AirbrakeY	= AirbrakeY
		trace.Entity.AirbrakeZ	= AirbrakeZ
		trace.Entity.ActivateKey = AcitvateKey
		trace.Entity.ActivateSPC = ActivateSPC
		trace.Entity.brakepercent = brakepercent
		trace.Entity.globalbrake = globalbrake
		trace.Entity.DrawSprite = DrawSprite
		trace.Entity.AlwaysAirbrake = AlwaysAirbrake
		trace.Entity.angbrake = AngularAirbrake
		trace.Entity.AirbrakeOnly = AirbrakeOnly
		if trace.Entity.Sound then
			trace.Entity.Sound:Stop()
			trace.Entity.Sound =  CreateSound( trace.Entity, sound )
			if trace.Entity.Active then
				trace.Entity.Sound:Play()
			end
		end
	return true end
	
	ent = MakeGravitycontroller( ply, Ang, Pos, AirbrakeOnly, AlwaysAirbrake, globalbrake, brakepercent, ActivateKey, ActivateSPC, AirbrakeX, AirbrakeY, AirbrakeZ, model, sound, AngularAirbrake, DrawSprite )
	ent:SetPos( trace.HitPos - trace.HitNormal * ent:OBBMins().z)
	
	if ( trace.Entity:IsValid() ) then
		const = constraint.Weld(ent, trace.Entity,0, trace.PhysicsBone, 0, systemmanager )
		nocollide = constraint.NoCollide( ent, trace.Entity, 0, trace.PhysicsBone )
		trace.Entity:DeleteOnRemove( ent )
	end

	undo.Create('gravitycontroller')
		undo.AddEntity( ent)
		undo.AddEntity( const )
		undo.AddEntity( nocollide )
		undo.SetPlayer( ply )
	undo.Finish()


	ply:AddCleanup( 'gravitycontroller', thruster )
	ply:AddCleanup( 'gravitycontroller', const )
	ply:AddCleanup( 'gravitycontroller', nocollide )
	
	return true
end


if SERVER then 
    CreateConVar( 'sbox_maxgravitycontroller',6 )
	function MakeGravitycontroller(ply, Ang, Pos, AirbrakeOnly, AlwaysAirbrake, globalbrake, brakepercent, ActivateKey, ActivateSPC, AirbrakeX, AirbrakeY, AirbrakeZ, model, sound, AngularAirbrake, DrawSprite)
	
		local ent = ents.Create( 'gravitycontroller' )
			if !ent:IsValid() then return false end	
			
			ent:SetAngles(Ang)
			ent:SetPos(Pos)
			
			ent.ActivateKey = ActivateKey
			ent.ActivateSPC = ActivateSPC
			ent.model = model
			ent.brakepercent = brakepercent
			ent.globalbrake = globalbrake
			ent.HoverSound = sound
			ent.AirbrakeX = AirbrakeX
			ent.AirbrakeY = AirbrakeY
			ent.AirbrakeZ = AirbrakeZ
			ent.angbrake = AngularAirbrake
			ent.DrawSprite = DrawSprite
			ent.AlwaysAirbrake = AlwaysAirbrake
			ent.AirbrakeOnly = AirbrakeOnly
			ent:Spawn()

			ent:SetVar('Owner',ply)
			
			numpad.OnDown(ply, ActivateKey, 'FireGravitycontroller', ent )
			numpad.OnDown(ply, ActivateSPC, 'FireSPC', ent )
		
		local rtable = {
			ActivateKey = ActivateKey,
			ActivateSPC = ActivateSPC,
			AirbrakeX = AirbrakeX,
			AirbrakeY = AirbrakeY,
			AirbrakeZ = AirbrakeZ,
			brakepercent = brakepercent,
			globalbrake = globalbrake,
			model = model,
			sound = sound,
			Ang = Ang,
			Pos = Pos,
			AngularAirbrake = AngularAirbrake,
			DrawSprite = DrawSprite,
			AlwaysAirbrake = AlwaysAirbrake,
			AirbrakeOnly = AirbrakeOnly,
			}
			
		table.Merge(ent:GetTable(), rtable )
		
		ply:AddCount('gravcontroller', ent)
		
		return ent
	end
	duplicator.RegisterEntityClass( "gravitycontroller", MakeGravitycontroller, "ang", "pos", "AirbrakeOnly", "AlwaysAirbrake", "globalbrake", "brakepercent", "ActivateKey", "ActivateSPC", "AirbrakeX", "AirbrakeY", "AirbrakeZ", "model", "sound", "AngularAirbrake", "DrawSprite" )

end

function TOOL.BuildCPanel( cp )
	cp:AddControl( 'Header', { Text = '#Tool_gravitycontroller_name', Description	= '#Tool_gravitycontroller_desc' }  )
	
		cp:AddControl("ComboBox", {
		Label = "#Presets",
		MenuButton = "1",
		Folder = "gravitycontroller",
		
		Options = {
			Default = {
				gravitycontroller_AirbrakeX = "10",
				gravitycontroller_AirbrakeY = "10",
				gravitycontroller_AirbrakeZ = "10",
				gravitycontroller_BrakePercent = "10",
				gravitycontroller_GlobalBrake = "0",
				gravitycontroller_model = "models//props_c17/utilityconducter001.mdl",
				gravitycontroller_sound = "npc/scanner/combat_scan_loop2.wav",
				gravitycontroller_AngularAirbrake = 0,
				gravitycontroller_DrawSprite = 1,
				gravitycontroller_AirbrakeAlwaysOn = 1,
				gravitycontroller_AirbrakeOnly = 0,
			},
		},

		CVars = {
			[0] = "gravitycontroller_model",
			[1] = "gravitycontroller_sound",
			[3] = "gravitycontroller_AirbrakeX",
			[4] = "gravitycontroller_AirbrakeY",
			[5] = "gravitycontroller_AirbrakeZ",
			[6] = "gravitycontroller_AngularAirbrake",
			[7] = "gravitycontroller_brakepercent",
			[8] = "gravitycontroller_globalbrake",
			[9] = "gravitycontroller_DrawSprite",
			[10] = "gravitycontroller_AirbrakeAlwaysOn",
			[11] = "gravitycontroller_AirbrakeOnly",
		},
	})


	
	cp:AddControl( "PropSelect", {
		Label = "Model",
		ConVar = "gravitycontroller_model",
		Category = "",
		Models = list.Get( "GravControllerModels" )
	})

	combo = {}
	combo.Label = 'Gravity Controller Sound'
	combo.MenuButton = 0
	combo.Folder = 'settings/menu/main/construct/gravitycontroller/'
	combo.Options = {}

	for k, v in pairs(loopsounds) do
	  combo.Options[v[1]] = { gravitycontroller_sound = v[2] }
	end
	
	cp:AddControl(  "Label", { Text = "Sound" } )	
	cp:AddControl('ComboBox', combo)
	
	cp:AddControl( 'Slider', { 
		Label = 'AirbrakeX', 
		Type = "Float", 
		Min = 0, 
		Max = 100, 
		Command = 'gravitycontroller_AirbrakeX' 
	})

	cp:AddControl( 'Slider', { 
		Label = 'AirbrakeY', 
		Type = "Float", 
		Min = 0, 
		Max = 100, 
		Command = 'gravitycontroller_AirbrakeY' 
	})	
		
	cp:AddControl( 'Slider', { 
		Label = 'AirbrakeZ', 
		Type = "Float", 
		Min = 0, 
		Max = 100, 
		Command = 'gravitycontroller_AirbrakeZ' 
	})
	
	cp:CheckBox("Global Airbrake (Overrides X,Y,Z)","gravitycontroller_GlobalBrake");	
	
	cp:AddControl( 'Slider', { 
		Label = 'Global Airbrake %', 
		Type = "Float", 
		Min = 0, 
		Max = 100, 
		Command = "gravitycontroller_BrakePercent" 
	})
	
	cp:CheckBox("Angular Airbrake (uses Global Airbrake)","gravitycontroller_AngularAirbrake")	
	cp:CheckBox("Airbrake always on","gravitycontroller_AirbrakeAlwaysOn")
	
	cp:AddControl('Numpad', { 
		ButtonSize = '22', 
		Label = 'Activate', 
		Command = "gravitycontroller_ActivateKey",
		Label2 = 'Space Poscorrection',
		Command2 = "gravitycontroller_ActivateSPC",
	})
	
	cp:CheckBox("Draw sprite","gravitycontroller_DrawSprite")

	cp:CheckBox("Only Airbrake","gravitycontroller_AirbrakeOnly")
	
end

function TOOL:UpdateSpawnGhost( ent, player )
	if ( !ent ) then return end
	if ( !ent:IsValid() ) then return end

	local tr 	= utilx.GetPlayerTrace( player, player:GetCursorAimVector() )
	local trace 	= util.TraceLine( tr )
	if (!trace.Hit) then return end
	
	if (trace.Entity && trace.Entity:GetClass() == "gravitycontroller" || trace.Entity:IsPlayer() ) then
	
		ent:SetNoDraw( true )
		return
		
	end
	
	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90
	ent:SetAngles( Ang )
	
	local min = ent:OBBMins()
	ent:SetPos( trace.HitPos - trace.HitNormal * min.z )
	
	ent:SetNoDraw( false )
end


function TOOL:Think()
	if (!self:GetClientInfo('model')) then return end
	local model	= self:GetClientInfo('model')
	
	if (!self.GhostEntity || !self.GhostEntity:IsValid() || self.GhostEntity:GetModel() != model) then
		self:MakeGhostEntity( model, Vector(0,0,0), Angle(0,0,0) )
	end
	
	self:UpdateSpawnGhost( self.GhostEntity, self:GetOwner() )
end
